import { OnDestroy } from '@angular/core';
import { ShContextMenuComponent } from './sh-context-menu.component';
import { Overlay } from '@angular/cdk/overlay';
import { ShContextMenuEvent, ShContextSubMenuEvent } from './sh-context-menu.models';
import { OverlayRef } from '@angular/cdk/overlay';
import { Subscription } from 'rxjs';
export declare class ShContextMenuService implements OnDestroy {
    private overlay;
    activeOverlays: OverlayRef[];
    backDropSub: Subscription;
    activeMenu: ShContextMenuComponent;
    constructor(overlay: Overlay);
    openMenu(ctxEvent: ShContextMenuEvent): void;
    openSubMenu(ctxEvent: ShContextSubMenuEvent): any;
    destroy(): void;
    ngOnDestroy(): void;
    closeSubMenus(menu: ShContextMenuComponent): void;
    private registerBackdropEvents;
    private createAndAttachOverlay;
    private buildCloseScrollStrategy;
    private buildConnectedPositionStrategy;
    private buildConnectedPositionStrategyForSubMenu;
    private overrideGetBoundingClientRect;
    private closeCurrentOverlays;
    private attachContextToItems;
    private attachThisContext;
    private attachOverlayRef;
}
